Index: cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1676)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1693)
@@ -3112,19 +3189,19 @@
 
   FirstItem := TextToShow(Strings[0]);
-  LastItem  := TextToShow(Strings[Strings.Count-1]);
+  LastItem := TextToShow(Strings[Strings.Count - 1]);
   Ascend := True;
   case FDirection of
-  LL_REVERSE: if CompareText(FirstItem, LastItem) < 0 then Ascend := False;
-  LL_FORWARD: if CompareText(FirstItem, LastItem) > 0 then Ascend := False;
-  end;
-  case Ascend of                              // should call AddObject & InsertObject instead?
-  False: case FDirection of
-         LL_REVERSE: for i := Strings.Count - 1 downto 0 do Items.Insert(FInsertAt, Strings[i]);
-         LL_FORWARD: for i := Strings.Count - 1 downto 0 do Items.Add(Strings[i]);
-         end;
-  True:  case FDirection of
-         LL_REVERSE: for i := 0 to Strings.Count - 1 do Items.Insert(FInsertAt, Strings[i]);
-         LL_FORWARD: for i := 0 to Strings.Count - 1 do Items.Add(Strings[i]);
-         end;
+    LL_REVERSE: if CompareText(FirstItem, LastItem) < 0 then Ascend := False;
+    LL_FORWARD: if CompareText(FirstItem, LastItem) > 0 then Ascend := False;
+  end;
+  case Ascend of // should call AddObject & InsertObject instead?
+    False: case FDirection of
+        LL_REVERSE: for i := Strings.Count - 1 downto 0 do Items.Insert(FInsertAt, Strings[i]);
+        LL_FORWARD: for i := Strings.Count - 1 downto 0 do Items.Add(Strings[i]);
+      end;
+    True: case FDirection of
+        LL_REVERSE: for i := 0 to Strings.Count - 1 do Items.Insert(FInsertAt, Strings[i]);
+        LL_FORWARD: for i := 0 to Strings.Count - 1 do Items.Add(Strings[i]);
+      end;
   end;
 end;
@@ -3141,5 +3218,5 @@
       index := GetStringIndex(S);
       if index > -1 then
-        S := Piece(Items[index],Delimiter,LookUpPiece);
+        S := Piece(Items[index], Delimiter, LookUpPiece);
     end;
     if CaseChanged then
@@ -3157,6 +3234,6 @@
   if FWaterMark > 0 then
   begin
-    Items.Insert(FWaterMark,LLS_LINE);
-    Items.Insert(FWaterMark,LLS_SPACE);
+    Items.Insert(FWaterMark, LLS_LINE);
+    Items.Insert(FWaterMark, LLS_SPACE);
   end;
 end;
@@ -3184,8 +3261,8 @@
   begin
     case FDirection of
-    LL_REVERSE:  for i := Items.Count - 1 downto
-                  HigherOf(FCurrentTop + FLargeChange, FWaterMark) do Items.Delete(i);
-    LL_POSITION: for i := Items.Count - 1 downto FWaterMark do Items.Delete(i);
-    LL_FORWARD:  for i := FCurrentTop - 1 downto FWaterMark do Items.Delete(i);
+      LL_REVERSE: for i := Items.Count - 1 downto
+        HigherOf(FCurrentTop + FLargeChange, FWaterMark) do Items.Delete(i);
+      LL_POSITION: for i := Items.Count - 1 downto FWaterMark do Items.Delete(i);
+      LL_FORWARD: for i := FCurrentTop - 1 downto FWaterMark do Items.Delete(i);
     end;
   end;
@@ -3199,16 +3276,16 @@
   if Items.Count > 1000 then ClearLong;
   case FDirection of
-  LL_REVERSE:  if FWaterMark < Items.Count then StartFrom := DisplayText[FWaterMark];
-  LL_POSITION: begin
-                 ClearLong;
-                 if StartFrom = #127#127#127 then
-                 begin
-                   FDirection := LL_REVERSE;
-                   StartFrom := '';
-                 end
-                 else FDirection := LL_FORWARD;
-               end;
-  LL_FORWARD:  if (FWaterMark < Items.Count) and (Items.Count > 0)
-                 then StartFrom := DisplayText[Items.Count - 1];
+    LL_REVERSE: if FWaterMark < Items.Count then StartFrom := DisplayText[FWaterMark];
+    LL_POSITION: begin
+        ClearLong;
+        if StartFrom = #127#127#127 then
+        begin
+          FDirection := LL_REVERSE;
+          StartFrom := '';
+        end
+        else FDirection := LL_FORWARD;
+      end;
+    LL_FORWARD: if (FWaterMark < Items.Count) and (Items.Count > 0)
+      then StartFrom := DisplayText[Items.Count - 1];
   end;
   if LookupPiece <> 0 then
@@ -3216,15 +3293,15 @@
     index := GetStringIndex(StartFrom);
     if index > -1 then
-      StartFrom := Piece(Items[index],Delimiter,LookUpPiece);
+      StartFrom := Piece(Items[index], Delimiter, LookUpPiece);
   end;
   if CaseChanged then
     StartFrom := Uppercase(StartFrom);
-  StartFrom := Copy(StartFrom, 1, 128);       // limit length to 128 characters
-  CtrlPos := 0;                               // make sure no ctrl characters
+  StartFrom := Copy(StartFrom, 1, 128); // limit length to 128 characters
+  CtrlPos := 0; // make sure no ctrl characters
   for CharPos := 1 to Length(StartFrom) do if StartFrom[CharPos] in [#0..#31] then
-  begin
-    CtrlPos := CharPos;
-    break;
-  end;
+    begin
+      CtrlPos := CharPos;
+      break;
+    end;
   if CtrlPos > 0 then StartFrom := Copy(StartFrom, 1, CtrlPos - 1);
   if FDirection = LL_FORWARD then FInsertAt := Items.Count else FInsertAt := FWaterMark;
@@ -3243,7 +3320,7 @@
   x := DisplayText[TopIndex];
   if (FWaterMark > 0) and (TopIndex < FWaterMark)
-    then Result := 0  // short list visible
-    else while (CompareText(ALPHA_DISTRIBUTION[Result], x) < 0) and (Result < 100) do
-      Inc(Result);    // only long list visible
+    then Result := 0 // short list visible
+  else while (CompareText(ALPHA_DISTRIBUTION[Result], x) < 0) and (Result < 100) do
+      Inc(Result); // only long list visible
 end;
 
@@ -3251,88 +3328,96 @@
 { event code for the longlist scrollbar, adjusts TopIndex & calls OnNeedData as necessary }
 var
-  Count, Goal, Dir :integer;
-  Done :boolean;
-
-begin
+  Count, Goal, Dir: integer;
+  Done: boolean;
+  DropDownPanel: TORListBox;
+begin
+  If Length(HintArray) > 0 then begin
+   DropDownPanel := TORListBox.Create(nil);
+   try
+    DropDownPanel.SetHintProperties(True, GetParentForm(Self));
+   finally
+    DropDownPanel.Free;
+   end;
+  end;
   uItemTip.Hide;
   FCurrentTop := TopIndex;
-  if(ScrollCode = scPosition) then
+  if (ScrollCode = scPosition) then
   begin
     NeedData(LL_POSITION, ALPHA_DISTRIBUTION[ScrollPos]);
     case ScrollPos of
-    0:     TopIndex := 0;
-    1..99: TopIndex := FWaterMark;
-    100:   TopIndex := HigherOf(Items.Count - FLargeChange, 0);
+      0: TopIndex := 0;
+      1..99: TopIndex := FWaterMark;
+      100: TopIndex := HigherOf(Items.Count - FLargeChange, 0);
     end;
     FFocusIndex := TopIndex;
   end
   else
-  if(HideSynonyms) then
-  begin
-    Count := 0;
-    case ScrollCode of
-      scLineUp:   begin Dir := -1; Goal := 1;            end;
-      scLineDown: begin Dir :=  1; Goal := 1;            end;
-      scPageUp:   begin Dir := -1; Goal := FLargeChange; end;
-      scPageDown: begin Dir :=  1; Goal := FLargeChange; end;
+    if (HideSynonyms) then
+    begin
+      Count := 0;
+      case ScrollCode of
+        scLineUp: begin Dir := -1; Goal := 1; end;
+        scLineDown: begin Dir := 1; Goal := 1; end;
+        scPageUp: begin Dir := -1; Goal := FLargeChange; end;
+        scPageDown: begin Dir := 1; Goal := FLargeChange; end;
       else
         exit;
-    end;
-    repeat
-      Done := FALSE;
-      if(Dir > 0) then
-      begin
-        if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1) then
-          NeedData(LL_FORWARD, '');
-        if(FCurrentTop >= Items.Count - 1) then
+      end;
+      repeat
+        Done := FALSE;
+        if (Dir > 0) then
         begin
-          FCurrentTop := Items.Count - 1;
-          Done := TRUE;
+          if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1) then
+            NeedData(LL_FORWARD, '');
+          if (FCurrentTop >= Items.Count - 1) then
+          begin
+            FCurrentTop := Items.Count - 1;
+            Done := TRUE;
+          end;
+        end
+        else
+        begin
+          if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
+          if (FCurrentTop <= 0) then
+          begin
+            FCurrentTop := 0;
+            Done := TRUE;
+          end;
         end;
-      end
-      else
-      begin
-        if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
-        if(FCurrentTop <= 0) then
+        if (not Done) then
         begin
-          FCurrentTop := 0;
-          Done := TRUE;
+          FCurrentTop := FCurrentTop + Dir;
+          if (Perform(LB_GETITEMHEIGHT, FCurrentTop, 0) > 0) then
+          begin
+            inc(Count);
+            Done := (Count >= Goal);
+          end;
         end;
+      until Done;
+      TopIndex := FCurrentTop;
+    end
+    else
+    begin
+      case ScrollCode of
+        scLineUp: begin
+            if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
+            TopIndex := HigherOf(FCurrentTop - 1, 0);
+          end;
+        scLineDown: begin
+            if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1)
+              then NeedData(LL_FORWARD, '');
+            TopIndex := LowerOf(FCurrentTop + 1, Items.Count - 1);
+          end;
+        scPageUp: begin
+            if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
+            TopIndex := HigherOf(FCurrentTop - FLargeChange, 0);
+          end;
+        scPageDown: begin
+            if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1)
+              then NeedData(LL_FORWARD, '');
+            TopIndex := LowerOf(FCurrentTop + FLargeChange, Items.Count - 1);
+          end;
       end;
-      if(not Done) then
-      begin
-        FCurrentTop := FCurrentTop + Dir;
-        if(Perform(LB_GETITEMHEIGHT, FCurrentTop, 0) > 0) then
-        begin
-          inc(Count);
-          Done := (Count >= Goal);
-        end;
-      end;
-    until Done;
-    TopIndex := FCurrentTop;
-  end
-  else
-  begin
-    case ScrollCode of
-    scLineUp:   begin
-                  if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
-                  TopIndex := HigherOf(FCurrentTop - 1, 0);
-                end;
-    scLineDown: begin
-                  if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1)
-                    then NeedData(LL_FORWARD, '');
-                  TopIndex := LowerOf(FCurrentTop + 1, Items.Count - 1);
-                end;
-    scPageUp:   begin
-                  if (FCurrentTop - FLargeChange) < FWaterMark then NeedData(LL_REVERSE, '');
-                  TopIndex := HigherOf(FCurrentTop - FLargeChange, 0);
-                end;
-    scPageDown: begin
-                  if (FCurrentTop + (FLargeChange * 2)) > (Items.Count - 1)
-                    then NeedData(LL_FORWARD, '');
-                  TopIndex := LowerOf(FCurrentTop + FLargeChange, Items.Count - 1);
-                end;
-    end;
-  end;
+    end;
   if (ScrollPos > 0) and (ScrollPos < 100) then ScrollPos := PositionThumb;
 end;
@@ -3344,20 +3429,20 @@
 begin
   Result := -1;
-  if Length(AString) > 0 then                                             {*KCM*}
-  begin
-    if not FLongList then                                                 // Normal List
+  if Length(AString) > 0 then {*KCM*}
+  begin
+    if not FLongList then // Normal List
     begin
       Result := SendMessage(Handle, LB_FINDSTRING, -1, Longint(PChar(AString)));
       if Result = LB_ERR then Result := -1;
-    end else                                                              // Long List
+    end else // Long List
     begin
       if FScrollBar.Position = 0 then for i := 0 to FWatermark - 1 do
-      begin
-        if CompareText(AString, Copy(DisplayText[i], 1, Length(AString))) = 0 then
         begin
-          Result := i;
-          break;
+          if CompareText(AString, Copy(DisplayText[i], 1, Length(AString))) = 0 then
+          begin
+            Result := i;
+            break;
+          end;
         end;
-      end;
       if Result < 0 then
       begin
@@ -3377,7 +3462,7 @@
 begin
   Result := -1;
-  if Length(AString) > 0 then                                             {*KCM*}
-  begin
-    if not FLongList then                                                 // Normal List
+  if Length(AString) > 0 then {*KCM*}
+  begin
+    if not FLongList then // Normal List
     begin
       Result := SendMessage(Handle, LB_FINDSTRING, -1, Longint(PChar(AString)));
@@ -3385,14 +3470,14 @@
       // use FFocusIndex instead of FocusIndex to reduce flashing
       FFocusIndex := Result;
-    end else                                                              // Long List
+    end else // Long List
     begin
       if FScrollBar.Position = 0 then for i := 0 to FWatermark - 1 do
-      begin
-        if CompareText(AString, Copy(DisplayText[i], 1, Length(AString))) = 0 then
         begin
-          Result := i;
-          break;
+          if CompareText(AString, Copy(DisplayText[i], 1, Length(AString))) = 0 then
+          begin
+            Result := i;
+            break;
+          end;
         end;
-      end;
       if not StringBetween(AString, DisplayText[FWaterMark], DisplayText[Items.Count - 1]) then
       begin
@@ -3402,5 +3487,5 @@
           index := GetStringIndex(x);
           if index > -1 then
-            x := Piece(Items[index],Delimiter,LookUpPiece);
+            x := Piece(Items[index], Delimiter, LookUpPiece);
         end;
         if CaseChanged then
@@ -3421,18 +3506,18 @@
   ItemIndex := Result;
   FFocusIndex := Result;
-  if Result > -1 then TopIndex := Result;                  // will scroll item into view
-  if FLongList then FScrollBar.Position := PositionThumb;  // done after topindex set
+  if Result > -1 then TopIndex := Result; // will scroll item into view
+  if FLongList then FScrollBar.Position := PositionThumb; // done after topindex set
 end;
 
 procedure TORListBox.SetCheckBoxes(const Value: boolean);
 begin
-  if(FCheckBoxes <> Value) then
+  if (FCheckBoxes <> Value) then
   begin
     FCheckBoxes := Value;
-    if(Value) then
-    begin
-      if(GetStyle = lbStandard) then
+    if (Value) then
+    begin
+      if (GetStyle = lbStandard) then
         SetStyle(lbOwnerDrawFixed);
-      if(inherited MultiSelect) then
+      if (inherited MultiSelect) then
         SetMultiSelect(FALSE);
     end;
@@ -3443,5 +3528,5 @@
 procedure TORListBox.SetFlatCheckBoxes(const Value: boolean);
 begin
-  if(FFlatCheckBoxes <> Value) then
+  if (FFlatCheckBoxes <> Value) then
   begin
     FFlatCheckBoxes := Value;
@@ -3458,7 +3543,7 @@
   if Index < 0 then exit;
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := FALSE;
-  if(assigned(ItemRec)) then
+  if (assigned(ItemRec)) then
     Result := (ItemRec^.CheckedState = cbChecked)
   else
@@ -3473,9 +3558,9 @@
 begin
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := False;
   if (assigned(ItemRec)) and (Value <> (ItemRec^.CheckedState = cbChecked)) then
   begin
-    if(Value) then
+    if (Value) then
       ItemRec^.CheckedState := cbChecked
     else
@@ -3483,5 +3568,5 @@
     Rect := ItemRect(Index);
     InvalidateRect(Handle, @Rect, FALSE);
-    if(assigned(FOnClickCheck)) then
+    if (assigned(FOnClickCheck)) then
       FOnClickCheck(Self, Index);
   end;
@@ -3494,7 +3579,7 @@
 begin
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := FALSE;
-  if(assigned(ItemRec)) then
+  if (assigned(ItemRec)) then
     Result := ItemRec^.CheckedState
   else
@@ -3510,5 +3595,5 @@
 begin
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := False;
   if (assigned(ItemRec)) and (Value <> ItemRec^.CheckedState) then
@@ -3517,5 +3602,5 @@
     Rect := ItemRect(Index);
     InvalidateRect(Handle, @Rect, FALSE);
-    if(assigned(FOnClickCheck)) then
+    if (assigned(FOnClickCheck)) then
       FOnClickCheck(Self, Index);
   end;
@@ -3530,5 +3615,5 @@
 begin
   inherited SetMultiSelect(Value);
-  if(Value) then SetCheckBoxes(FALSE);
+  if (Value) then SetCheckBoxes(FALSE);
 end;
 
@@ -3539,7 +3624,7 @@
 begin
   Result := '';
-  if(FCheckBoxes) then
-  begin
-    for i := 0 to Items.Count-1 do
+  if (FCheckBoxes) then
+  begin
+    for i := 0 to Items.Count - 1 do
       Result := Result + Char(ord('0') + Ord(GetCheckedState(i)));
   end;
@@ -3551,6 +3636,6 @@
 
 begin
-  for i := 0 to Items.Count-1 do
-    SetCheckedState(i, TCheckBoxState(StrToIntDef(copy(Value,i+1,1),0)));
+  for i := 0 to Items.Count - 1 do
+    SetCheckedState(i, TCheckBoxState(StrToIntDef(copy(Value, i + 1, 1), 0)));
 end;
 
@@ -3558,13 +3643,13 @@
 begin
   if not Assigned(FMItems) then
-    FMItems := TORStrings.Create(Tlistbox(Self).Items,TextToShow);
+    FMItems := TORStrings.Create(Tlistbox(Self).Items, TextToShow);
   result := FMItems;
 end;
 
-procedure TORListBox.SetMItems( Value: TStrings);
+procedure TORListBox.SetMItems(Value: TStrings);
 begin
   if not Assigned(FMItems) then
-    FMItems := TORStrings.Create(Tlistbox(Self).Items,TextToShow);
-  FMItems.Assign( Value );
+    FMItems := TORStrings.Create(Tlistbox(Self).Items, TextToShow);
+  FMItems.Assign(Value);
 end;
 
@@ -3588,5 +3673,5 @@
     FCaption.Width := 0;
     FCaption.Visible := True;
-    if Assigned (FParentCombo) then
+    if Assigned(FParentCombo) then
       FCaption.Parent := FParentCombo
     else
@@ -3612,7 +3697,7 @@
 procedure DropDownPanelOpened;
 begin
-  if uDropPanelOpenCount=0 then
+  if uDropPanelOpenCount = 0 then
     uOldShowHintsSetting := Application.ShowHint;
-  Application.ShowHint := FALSE;
+ // Application.ShowHint := FALSE;
   inc(uDropPanelOpenCount);
 end;
@@ -3621,9 +3706,9 @@
 begin
   dec(uDropPanelOpenCount);
-  if uDropPanelOpenCount<=0 then
+  if uDropPanelOpenCount <= 0 then
   begin
     uDropPanelOpenCount := 0;
     if not Application.ShowHint then
-      Application.ShowHint := uOldShowHintsSetting
+  //    Application.ShowHint := uOldShowHintsSetting
   end;
 end;
@@ -3649,5 +3734,5 @@
   BevelOuter := bvNone;
   BorderStyle := bsNone;
-  Caption :='';
+  Caption := '';
   Ctl3D := False;
   Visible := False;
@@ -3660,10 +3745,10 @@
   inherited CreateParams(Params);
   if not (csDesigning in ComponentState) then with Params do
-  begin
-    if uNewStyle then Params.ExStyle := Params.ExStyle or WS_EX_TOOLWINDOW;
-    Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;  // - incompatible with ItemTip
-    WindowClass.Style := WindowClass.Style or CS_SAVEBITS;
-    WndParent := GetDesktopWindow;
-  end;
+    begin
+      if uNewStyle then Params.ExStyle := Params.ExStyle or WS_EX_TOOLWINDOW;
+      Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST; // - incompatible with ItemTip
+      WindowClass.Style := WindowClass.Style or CS_SAVEBITS;
+      WndParent := GetDesktopWindow;
+    end;
 end;
 
@@ -3674,11 +3759,11 @@
 begin
   Result := nil;
-  if(FButtons) then
-  begin
-    for i := 0 to ControlCount-1 do
-      if(Controls[i] is TSpeedButton) then
+  if (FButtons) then
+  begin
+    for i := 0 to ControlCount - 1 do
+      if (Controls[i] is TSpeedButton) then
       begin
-        if((OKBtn and ((Controls[i] as TSpeedButton).Tag = OKBtnTag)) or
-           ((not OKBtn) and ((Controls[i] as TSpeedButton).Tag = CancelBtnTag))) then
+        if ((OKBtn and ((Controls[i] as TSpeedButton).Tag = OKBtnTag)) or
+          ((not OKBtn) and ((Controls[i] as TSpeedButton).Tag = CancelBtnTag))) then
         begin
           Result := TSpeedButton(Controls[i]);
@@ -3695,7 +3780,7 @@
 begin
   sb := GetButton(TRUE);
-  if(assigned(sb)) then sb.Down := FALSE;
+  if (assigned(sb)) then sb.Down := FALSE;
   sb := GetButton(FALSE);
-  if(assigned(sb)) then sb.Down := FALSE;
+  if (assigned(sb)) then sb.Down := FALSE;
 end;
 
@@ -3707,17 +3792,17 @@
 begin
   inherited;
-  if(FButtons) then
+  if (FButtons) then
   begin
     btn := GetButton(TRUE);
-    if(assigned(btn)) then
+    if (assigned(btn)) then
     begin
       half := width div 2;
       btn.Left := 0;
       btn.Width := Half;
-      btn.Top := Height-btn.Height;
+      btn.Top := Height - btn.Height;
       btn := GetButton(FALSE);
       btn.Left := Half;
       btn.Width := Width - Half;
-      btn.Top := Height-btn.Height;
+      btn.Top := Height - btn.Height;
     end;
   end;
@@ -3728,11 +3813,11 @@
   btn: TSpeedButton;
   cbo: TORComboBox;
-  i:integer;
+  i: integer;
 
 begin
   cbo := (Owner as TORComboBox);
-  if(cbo.FListBox.FCheckBoxes) then
-  begin
-    if(not FButtons) then
+  if (cbo.FListBox.FCheckBoxes) then
+  begin
+    if (not FButtons) then
     begin
       btn := TSpeedButton.Create(Self);
@@ -3757,12 +3842,12 @@
   end
   else
-  if(FButtons) then
-  begin
-    for i := ControlCount-1 downto 0 do
-      if(Controls[i] is TButton) then
-        Controls[i].Free;
-    FButtons := FALSE;
-    Resize;
-  end;
+    if (FButtons) then
+    begin
+      for i := ControlCount - 1 downto 0 do
+        if (Controls[i] is TButton) then
+          Controls[i].Free;
+      FButtons := FALSE;
+      Resize;
+    end;
 end;
 
@@ -3782,5 +3867,11 @@
 begin
   inherited CreateParams(Params);
-  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;
+// JM - removed multi-line - broke lookup when MaxLength is set, besides, it didn't really
+// seem to have an effect on the editing rectangle anyway.
+// agp change cause tab characters to show on meds and lab order dialogs
+//  Params.Style := Params.Style {or ES_MULTILINE} or WS_CLIPCHILDREN;
+    if TForm(self.Owner.Owner) <> nil then Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN
+    else Params.Style := Params.Style {or ES_MULTILINE} or WS_CLIPCHILDREN;
+
 end;
 
@@ -3791,6 +3882,6 @@
   begin
     if (FListBox.FCheckBoxes) and assigned(FEditPanel) and
-       (Message.FocusedWnd <> FListBox.Handle) and
-       ((not assigned(FDropBtn)) or (Message.FocusedWnd <> FDropBtn.Handle)) then
+      (Message.FocusedWnd <> FListBox.Handle) and
+      ((not assigned(FDropBtn)) or (Message.FocusedWnd <> FDropBtn.Handle)) then
     begin
       FEditPanel.FFocused := FALSE;
@@ -3845,10 +3936,10 @@
   FEditBox.OnKeyUp := FwdKeyUp;
   FEditBox.Visible := True;
-  fCharsNeedMatch := 1;  
+  fCharsNeedMatch := 1;
 end;
 
 procedure TORComboBox.WMDestroy(var Message: TWMDestroy);
 begin
-  if(assigned(Owner)) and (csDestroying in Owner.ComponentState) then
+  if (assigned(Owner)) and (csDestroying in Owner.ComponentState) then
     FListBox.DestroyItems;
   inherited;
@@ -3889,5 +3980,5 @@
 function TORComboBox.EditControl: TWinControl;
 begin
-  if(assigned(FEditPanel)) then
+  if (assigned(FEditPanel)) then
     Result := FEditPanel
   else
@@ -3899,5 +3990,5 @@
 var
   FontHeight: Integer;
-  cboBtnX,cboBtnY: integer;
+  cboBtnX, cboBtnY: integer;
   cboYMargin: integer;
 
@@ -3917,17 +4008,17 @@
     cboBtnY := CBO_CXFRAME;
   end;
-  Height := HigherOf(FontHeight + cboYMargin, Height);   // must be at least as high as text
+  Height := HigherOf(FontHeight + cboYMargin, Height); // must be at least as high as text
   EditControl.SetBounds(0, 0, Width, FontHeight + cboYMargin);
-  if(assigned(FEditPanel)) then
+  if (assigned(FEditPanel)) then
     FEditBox.SetBounds(2, 3, FEditPanel.Width - 4, FEditPanel.Height - 5);
   if FStyle = orcsDropDown then
   begin
-    Height := FontHeight + cboYMargin;                   // DropDown can only be text height
+    Height := FontHeight + cboYMargin; // DropDown can only be text height
     FDropBtn.SetBounds(EditControl.Width - CBO_CXBTN - cboBtnX, 0,
-                       CBO_CXBTN, EditControl.Height - cboBtnY);
+      CBO_CXBTN, EditControl.Height - cboBtnY);
   end else
   begin
     FListBox.SetBounds(0, FontHeight + CBO_CYMARGIN,
-                       Width, Height - FontHeight - CBO_CYMARGIN);
+      Width, Height - FontHeight - CBO_CYMARGIN);
   end;
   SetEditRect;
@@ -3950,34 +4041,45 @@
 { shift the focus back to the editbox so the focus rectangle doesn't clutter the button }
 begin
-  if FDroppedDown then FListBox.MouseCapture := True;  // do here so 1st buttonup not captured
+  if FDroppedDown then FListBox.MouseCapture := True; // do here so 1st buttonup not captured
   FEditBox.SetFocus;
 end;
 
 procedure TORComboBox.DropDownStatusChanged(opened: boolean);
-begin
-  if opened then
-  begin
-    if not FDropPanel.Visible then
-    begin
-      if FDropDownStatusChangedCount = 0 then
+var
+  DropDownPanel: TORListBox;
+begin
+  DropDownPanel := TORListBox.Create(nil);
+  try
+    if opened then
+    begin
+      if not FDropPanel.Visible then
       begin
-        FDisableHints := TRUE;
-        DropDownPanelOpened;
+        if FDropDownStatusChangedCount = 0 then
+        begin
+          FDisableHints := TRUE;
+          DropDownPanelOpened;
+        end;
+        inc(FDropDownStatusChangedCount);
       end;
-      inc(FDropDownStatusChangedCount);
-    end;
-  end
-  else
-  begin
-    dec(FDropDownStatusChangedCount);
-    if FDropDownStatusChangedCount <= 0 then
-    begin
-      if FDisableHints then
+    end
+    else
+    begin
+      dec(FDropDownStatusChangedCount);
+      if FDropDownStatusChangedCount <= 0 then
       begin
-        DropDownPanelClosed;
-        FDisableHints := FALSE;
+        //agp change
+        //if FDisableHints then
+        if (FDisableHints) and (Self.Owner <> nil) then
+        begin
+          DropDownPanelClosed;
+          FDisableHints := FALSE;
+          If (GetParentForm(Self) <> nil) then  
+           DropDownPanel.SetHintProperties(True, GetParentForm(Self));
+        end;
+        FDropDownStatusChangedCount := 0;
       end;
-      FDropDownStatusChangedCount := 0;
-    end;
+    end;
+  finally
+    DropDownPanel.Free;
   end;
 end;
@@ -4070,5 +4172,5 @@
 begin
   FChangePending := False;
-  if (not FListItemsOnly) and (Length(FEditBox.Text) > 0) and (FEditBox.SelStart = 0) then Exit;  // **KCM** test this!
+  if (not FListItemsOnly) and (Length(FEditBox.Text) > 0) and (FEditBox.SelStart = 0) then Exit; // **KCM** test this!
   with FEditBox do x := Copy(Text, 1, SelStart);
   FLastInput := x;
@@ -4079,5 +4181,5 @@
     SelectIndex := FListBox.SelectString(x);
   if UniqueAutoComplete then
-    SelectIndex := FListBox.VerifyUnique(SelectIndex,x);
+    SelectIndex := FListBox.VerifyUnique(SelectIndex, x);
   if FListItemsOnly and (SelectIndex < 0) and (x <> '') then
   begin
@@ -4086,8 +4188,8 @@
     SelectIndex := FListBox.SelectString(x);
     FEditBox.Text := GetEditBoxText(SelectIndex);
-    if(not FListBox.FCheckBoxes) then
+    if (not FListBox.FCheckBoxes) then
       SendMessage(FEditBox.Handle, EM_SETSEL, Length(FEditBox.Text), Length(x));
     FFromSelf := False;
-    Exit;                              // OnChange not called in this case
+    Exit; // OnChange not called in this case
   end;
   FFromSelf := True;
@@ -4096,16 +4198,16 @@
     FEditBox.Text := GetEditBoxText(SelectIndex);
     FLastFound := x;
-    if(not FListBox.FCheckBoxes) then
+    if (not FListBox.FCheckBoxes) then
       SendMessage(FEditBox.Handle, EM_SETSEL, Length(FEditBox.Text), Length(x));
   end else
   begin
-    if(FListBox.CheckBoxes) then
+    if (FListBox.CheckBoxes) then
       FEditBox.Text := GetEditBoxText(SelectIndex)
     else
-      FEditBox.Text := x;                // no match, so don't set FLastFound
+      FEditBox.Text := x; // no match, so don't set FLastFound
     FEditBox.SelStart := Length(x);
   end;
   FFromSelf := False;
-  if(not FListBox.FCheckBoxes) then
+  if (not FListBox.FCheckBoxes) then
     if Assigned(FOnChange) then FOnChange(Self);
 end;
@@ -4146,5 +4248,5 @@
   begin
     FFromSelf := True;
-    FListBox.FFocusIndex := FListBox.ItemIndex;  // FFocusIndex used so ItemTip doesn't flash
+    FListBox.FFocusIndex := FListBox.ItemIndex; // FFocusIndex used so ItemTip doesn't flash
     FEditBox.Text := GetEditBoxText(FListBox.ItemIndex);
     FLastFound := FEditBox.Text;
@@ -4152,11 +4254,11 @@
     // not sure why this must be posted (put at the back of the message queue), but for some
     // reason FEditBox.SelectAll selects successfully then deselects on exiting this procedure
-    if(not FListBox.FCheckBoxes) then
+    if (not FListBox.FCheckBoxes) then
       PostMessage(FEditBox.Handle, EM_SETSEL, 0, Length(FEditBox.Text));
     FEditBox.SetFocus;
   end;
   if Assigned(FOnClick) then FOnClick(Self);
-  if(not FListBox.FCheckBoxes) then
-    if Assigned(FOnChange) then FOnChange(Self);   // click causes both click & change events
+  if (not FListBox.FCheckBoxes) then
+    if Assigned(FOnChange) then FOnChange(Self); // click causes both click & change events
 end;
 
@@ -4170,12 +4272,12 @@
 { passed selected navigation keys to listbox, applies special handling to backspace and F4 }
 var
-  i,iPos: Integer;
-  x,AString: string;
+  i, iPos: Integer;
+  x, AString: string;
 begin
   // special case: when default action taken (RETURN) make sure FwdChangeDelayed is called first
   if (Key = VK_RETURN) and FListBox.LongList and FChangePending then FwdChangeDelayed;
-  StopKeyTimer;  // stop timer after control keys so in case an exit event is triggered
+  StopKeyTimer; // stop timer after control keys so in case an exit event is triggered
   if Assigned(FOnKeyDown) then FOnKeyDown(Self, Key, Shift);
-  if Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then                           // navigation
+  if Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then // navigation
   begin
     if (FStyle = orcsDropDown) and not DroppedDown then DroppedDown := True;
@@ -4192,5 +4294,5 @@
         if iPos > -1 then
         begin
-          FListBox.FFocusIndex := iPos-1;
+          FListBox.FFocusIndex := iPos - 1;
           FListBox.ItemIndex := FListBox.FFocusIndex;
         end;
@@ -4199,5 +4301,5 @@
     FListBox.Perform(WM_KEYDOWN, Key, 1);
   end;
-  if Key in [VK_LBUTTON, VK_RETURN, VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then    // select item
+  if Key in [VK_LBUTTON, VK_RETURN, VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then // select item
   begin
     FListBox.Perform(WM_KEYDOWN, VK_LBUTTON, 1);
@@ -4206,5 +4308,5 @@
     begin
       FEditBox.Text := GetEditBoxText(FListBox.ItemIndex);
-      FLastFound := FEditBox.Text;  //kcm
+      FLastFound := FEditBox.Text; //kcm
     end;
     FFromSelf := False;
@@ -4212,5 +4314,5 @@
   // tell parent about RETURN, ESCAPE so that the default action is taken
   if Key in [VK_RETURN, VK_ESCAPE, VK_TAB] then SendMessage(Parent.Handle, CN_KEYDOWN, Key, 0);
-  if Key = VK_BACK then                                                        // backspace
+  if Key = VK_BACK then // backspace
   begin
     FFromSelf := True;
@@ -4218,5 +4320,5 @@
     i := FEditBox.SelStart;
     Delete(x, i + 1, Length(x));
-    if(FListBox.FCheckBoxes) then
+    if (FListBox.FCheckBoxes) then
       FEditBox.Text := GetEditBoxText(ItemIndex)
     else
@@ -4295,5 +4397,5 @@
 { for DropDown combo, display the listbox at the appropriate full screen coordinates }
 const
-  MIN_ITEMS = 3;                                  // minimum visible items for long list
+  MIN_ITEMS = 3; // minimum visible items for long list
 var
   ScreenPoint: TPoint;
@@ -4308,5 +4410,5 @@
     if FListBox.LongList
       then DropDownCnt := HigherOf(FDropDownCount, MIN_ITEMS)
-      else DropDownCnt := LowerOf(FDropDownCount, FListBox.Items.Count);
+    else DropDownCnt := LowerOf(FDropDownCount, FListBox.Items.Count);
     FListBox.SetBounds(0, 0, Width, (FListBox.ItemHeight * DropDownCnt) + CBO_CXFRAME);
     // need to make this smart enough to drop the list UP when necessary ***
